## GPUCloudSim: an extension of CloudSim for modeling and simulation of GPUs in cloud data centers

In order to satisfy graphical and computational requirements of end-users, today cloud providers offer GPU-enabled services. To ease-up conducting experimental studies on GPU-enabled cloud computing environments, we provide an extension to [CloudSim](http://cloudbus.org/cloudsim/) simulator. Our extension includes models and provisioning and scheduling policies to enable the modeling and simulation of GPUs in data centers.  

-----------------------------------------
If you used the extension, please consider citing the following paper, 
> Siavashi, A., Momtazpour, M. GPUCloudSim: an extension of CloudSim for modeling and simulation of GPUs in cloud data centers. J Supercomput 75, 2535–2561 (2019). 
-----------------------------------------

We are constantly adding new features to the extension. Please consider reporting any issue you find helpful to improve the quality of the work.

### Main features

  * Support for modeling and simulation of large scale GPU-enabled cloud platforms
  * Support for modeling and simulation of energy-aware GPU-equipped data centers
  * Support for modeling and simulation of multi-video card servers
  * Support for modeling and simulation of multi-GPU video cards
  * Support for modeling and simulation of GPU-enabled VMs
  * Support for simulation of mixed workload and heterogeneous infrastructure
  * Support for user-defined GPU scheduling policies
  * Support for user-defined GPU provisioning policies
  * Support for modeling and simulation of GPU applications
  * Support for user-defined GPU application scheduling policies
  * Support for modeling and simulation of GPU remoting virtualization technology ([Siavashi et al. 2022](https://papers.ssrn.com/sol3/papers.cfm?abstract_id=4030263))
  * Support for modeling and simulation of NVIDIA GRID GPU virtualization technology
  * Support for modeling and simulation of full and para GPU virtualization technologies
  * Support for modeling and simulation of virtualization-incurred performance overhead
  * Support for modeling and simulation of interference among co-running GPU applications

### Download

This package contains CloudSim 4.0 with the latest version of the GPU extension.

### Disclaimer

This code is provided as is, and no guarantee is given that this code will preform in the desired way.
